;								MARZO 2001	
;		LAMP_LED					
;		LAMPEGGIATORE A LED "ROTANTI"
;
;			
	LIST P = 16F84		
       
;        __CONFIG 019h   ;CP off, PWRTE on, WDTE off, XT osc
;        radix DEC
	
INDEX   EQU     000H    ; use fsr for register number
RTCC    EQU     001H    ; real time clock
PC      EQU     002H    ; lower 8 bits of program counter
STATUS  EQU     003H    ; status register
FSR     EQU     004H    ; file select register
;
Port_A  EQU     005H    ; i/o port A
PORT_A  EQU     005H    ;
Port_B  EQU     006H    ; i/o port B
PORT_B  EQU     006H    ;
;                       ; register 7 not implemented
EDATA   EQU     008H    ; eeprom data register
EADR   EQU     009H    ; eeprom address register
;
PCLATH  EQU     00AH    ; holding register for high byte of pc
;
INTCON  EQU     00BH    ; interupt control register
;                       ; register 080H same as 000H
OPTREG  EQU     081H    ; option register
;                       ; registers 082H-084H same as 002H-004H
TRIS_A  EQU     085H    ; tri-state register for port A
TRISA  EQU     085H
TRIS_B  EQU     086H    ; tri-state register for port B
TRISB  EQU     086H    ;
;                       ; register 087H not implemented
ECON1   EQU     088H    ; eeprom control register 1
ECON2   EQU     089H    ; eeprom control register 2
;                       ; registers 08AH-08BH same as 00AH-00BH
;
;***************************
;
;       STATUS REGISTER BITS
;
CARRY   EQU     0H      ; Carry Bit
C       EQU     0H
DCARRY  EQU     1H      ; Digit Carry Bit
DC      EQU     1H
Z_bit   EQU     2H      ; Zero Bit
Z       EQU     2H
P_DOWN  EQU     3H      ; Power Down Bit
PD      EQU     3H
T_OUT   EQU     4H      ; TimeOut Bit
TO      EQU     4H

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;
;***************************
;
;       INTCON REGISTER BITS
;

;
;***************************
;
;       OPTION REGISTER BITS
;
PS0     EQU     0H      ; rtcc pre-scaler bit 0
PS1     EQU     1H      ; rtcc pre-scaler bit 1
PS2     EQU     2H      ; rtcc pre-scaler bit 2
PSA     EQU     3H      ; pre-scaler assignment bit
RTE     EQU     4H      ; rtcc signal edge
RTS     EQU     5H      ; rtcc signal source
INTEDG  EQU     6H      ; interupt edge detect
RBPU    EQU     7H      ; port B pull-up enable
;***************************


;
w       	equ     0
f       	equ     1
;
#define		_C      STATUS,C
#define 	_Z      STATUS,Z
#define 	_RP0    STATUS,RP0

#define		led_1		PORT_B,0
#define		led_2		PORT_B,1
#define		led_3		PORT_B,2
#define		led_4		PORT_B,3
#define		led_5		PORT_B,4
#define		led_6		PORT_B,5
#define		led_7		PORT_B,6
#define		led_8		PORT_B,7

#define		switch_1	PORT_A,0
#define		switch_2	PORT_A,1

#define		switch_3	PORT_A,2
#define		switch_4	PORT_A,3
			
#define		switch_5	PORT_A,4

buff_1  	equ     0ch	
buff_2  	equ     0dh	
buff_3  	equ     0eh	
buff_4  	equ     0fh	
buff_5  	equ     10h	
buff_6  	equ     11h	

	ORG     0
	goto	start

	ORG       4   
	retfie 

;********************** DELAY 0,1 s ***********************
_delay_01
	movlw	028h		; 028h
	movwf	buff_1
_delay_loop_1
	movlw	0ffh
	movwf	buff_2
_delay_loop_2
	nop
	decfsz	buff_2,f
	goto	_delay_loop_2
	nop
	decfsz	buff_1,f
	goto	_delay_loop_1		
	return

;-----------------------------------------------------------
;       	INIZIALIZZAZIONE
;-----------------------------------------------------------
start
        bsf     _RP0
        movlw   B'11111111'
        movwf   TRISA		;PORT_A tutti ingressi
        movlw   00h
        movwf   TRISB		;PORT_B tutte uscita
        movlw   B'10000111'     ;start prescaler,timer0
        movwf   OPTREG
        bcf     _RP0
	clrf	PORT_B
        
;***********************************************************
;*			ROTANTI 			   *	
;***********************************************************
_main
;	btfsc	switch_5
;	goto	_main_1
	
	bsf	led_1	
	call	_velocit
	call	_effetto_1
_main_led_2	
	bsf	led_2	
	call	_velocit
	call	_effetto_2
	
	bsf	led_3
	call	_velocit
	call	_effetto_3
	
	bsf	led_4	
	call	_velocit
	call	_effetto_4

	bsf	led_5	
	call	_velocit
	call	_effetto_5

	bsf	led_6	
	call	_velocit
	call	_effetto_6

	bsf	led_7	
	call	_velocit
	call	_effetto_7

	bsf	led_8	
	btfsc	switch_5
	goto	_main_1
	call	_velocit
	call	_effetto_8

;	btfsc	switch_5
;	goto	_main_1
	
	goto	_main

;**************** GESTIONE VELOCITA' ROTAZIONE LED *********
_velocit
	btfss	switch_1
	goto	_velocit_1
	btfss	switch_2
	goto	_velocit_2

	call	_delay_01
	return	

_velocit_1
	btfss	switch_2
	goto	_velocit_3
	
	movlw	03h
	movwf	buff_3	
_velocit_1a
	call	_delay_01
	decfsz	buff_3,f
	goto	_velocit_1a
	return

_velocit_2
	movlw	05h
	movwf	buff_3	
_velocit_2a
	call	_delay_01
	decfsz	buff_3,f
	goto	_velocit_2a
	return

_velocit_3
	movlw	08h
	movwf	buff_3	
_velocit_3a
	call	_delay_01
	decfsz	buff_3,f
	goto	_velocit_3a
	return

;**************** EFFETTO PER ROTANTI ******************
_effetto_1
	btfss	switch_3
	goto	_effetto_1a
	btfss	switch_4
	goto	_effetto_1b
	clrf	PORT_B			; 1 led 
	return
_effetto_1a
	btfss	switch_4
	goto	_effetto_1c
	bcf	led_8			; 2 led
	return
_effetto_1b
	bcf	led_7			; 3 led
	return
_effetto_1c
	bcf	led_6			; 4 led
	return

_effetto_2
	btfss	switch_3
	goto	_effetto_2a
	btfss	switch_4
	goto	_effetto_2b
	clrf	PORT_B
	return
_effetto_2a
	btfss	switch_4
	goto	_effetto_2c
	bcf	led_1
	return
_effetto_2b
	bcf	led_8
	return	
_effetto_2c
	bcf	led_7
	return	

_effetto_3
	btfss	switch_3
	goto	_effetto_3a
	btfss	switch_4
	goto	_effetto_3b
	clrf	PORT_B
	return
_effetto_3a
	btfss	switch_4
	goto	_effetto_3c
	bcf	led_2
	return
_effetto_3b
	bcf	led_1
	return
_effetto_3c
	bcf	led_8
	return

_effetto_4
	btfss	switch_3
	goto	_effetto_4a
	btfss	switch_4
	goto	_effetto_4b
	clrf	PORT_B
	return
_effetto_4a
	btfss	switch_4
	goto	_effetto_4c
	bcf	led_3
	return
_effetto_4b
	bcf	led_2
	return
_effetto_4c
	bcf	led_1
	return

_effetto_5
	btfss	switch_3
	goto	_effetto_5a
	btfss	switch_4
	goto	_effetto_5b
	clrf	PORT_B
	return
_effetto_5a
	btfss	switch_4
	goto	_effetto_5c
	bcf	led_4
	return
_effetto_5b
	bcf	led_3
	return
_effetto_5c
	bcf	led_2
	return

_effetto_6
	btfss	switch_3
	goto	_effetto_6a
	btfss	switch_4
	goto	_effetto_6b
	clrf	PORT_B
	return
_effetto_6a
	btfss	switch_4
	goto	_effetto_6c
	bcf	led_5
	return
_effetto_6b
	bcf	led_4
	return
_effetto_6c
	bcf	led_3
	return

_effetto_7
	btfss	switch_3
	goto	_effetto_7a
	btfss	switch_4
	goto	_effetto_7b
	clrf	PORT_B
	return
_effetto_7a
	btfss	switch_4
	goto	_effetto_7c
	bcf	led_6
	return
_effetto_7b
	bcf	led_5
	return
_effetto_7c
	bcf	led_4
	return

_effetto_8
	btfss	switch_3
	goto	_effetto_8a
	btfss	switch_4
	goto	_effetto_8b
	clrf	PORT_B
	return
_effetto_8a
	btfss	switch_4
	goto	_effetto_8c
	bcf	led_7
	return
_effetto_8b
	bcf	led_6
	return
_effetto_8c
	bcf	led_5
	return

_effetto_8_end
	btfss	switch_3
	goto	_effetto_8_end_a
	btfss	switch_4
	goto	_effetto_8_end_b
	call	_velocit
	bcf	led_8
	return
_effetto_8_end_a
	btfss	switch_4
	goto	_effetto_8_end_c
	call	_velocit
	bcf	led_7
	call	_velocit
	return
_effetto_8_end_b
	call	_velocit
	bcf	led_6
	call	_velocit
	bcf	led_7
	call	_velocit
	return
_effetto_8_end_c
	call	_velocit
	bcf	led_5
	call	_velocit
	bcf	led_6
	call	_velocit
	bcf	led_7
	call	_velocit
	return

;***********************************************************
;*			 AVANTI-INDIETRO 		   *	
;***********************************************************
_main_1
	btfss	switch_5
	goto	_main

	call	_effetto_8_end

_ritorno
	bsf	led_7	
	call	_velocit
	call	_effetto_7_ritorno
	
	bsf	led_6	
	call	_velocit
	call	_effetto_6_ritorno
	
	bsf	led_5
	call	_velocit
	call	_effetto_5_ritorno
	
	bsf	led_4	
	call	_velocit
	call	_effetto_4_ritorno

	bsf	led_3	
	call	_velocit
	call	_effetto_3_ritorno

	bsf	led_2
	call	_velocit
	call	_effetto_2_ritorno

	bsf	led_1	
;	call	_velocit
;	call	_effetto_1_ritorno

	call	_effetto_1_end
	goto	_main_led_2

;*************** EFFETTO PER ROTANTI *************************
_effetto_7_ritorno
	btfss	switch_3
	goto	_effetto_7a_ritorno
	btfss	switch_4
	goto	_effetto_7b_ritorno
	clrf	PORT_B
	return
_effetto_7a_ritorno
	btfss	switch_4
	goto	_effetto_7c_ritorno
	bcf	led_8
	return
_effetto_7b_ritorno
	return
_effetto_7c_ritorno
	return


_effetto_6_ritorno
	btfss	switch_3
	goto	_effetto_6a_ritorno
	btfss	switch_4
	goto	_effetto_6b_ritorno
	clrf	PORT_B
	return
_effetto_6a_ritorno
	btfss	switch_4
	goto	_effetto_6c_ritorno
	bcf	led_7
	return
_effetto_6b_ritorno
	bcf	led_8
	return
_effetto_6c_ritorno

	return

_effetto_5_ritorno
	btfss	switch_3
	goto	_effetto_5a_ritorno
	btfss	switch_4
	goto	_effetto_5b_ritorno
	clrf	PORT_B
	return
_effetto_5a_ritorno
	btfss	switch_4
	goto	_effetto_5c_ritorno
	bcf	led_6
	return
_effetto_5b_ritorno
	bcf	led_7
;	bcf	led_8
	return
_effetto_5c_ritorno
	bcf	led_8
	return

_effetto_4_ritorno
	btfss	switch_3
	goto	_effetto_4a_ritorno
	btfss	switch_4
	goto	_effetto_4b_ritorno
	clrf	PORT_B
	return
_effetto_4a_ritorno
	btfss	switch_4
	goto	_effetto_4c_ritorno
	bcf	led_5
	return
_effetto_4b_ritorno
	bcf	led_6
	return
_effetto_4c_ritorno
	bcf	led_7
	return

_effetto_3_ritorno
	btfss	switch_3
	goto	_effetto_3a_ritorno
	btfss	switch_4
	goto	_effetto_3b_ritorno
	clrf	PORT_B
	return
_effetto_3a_ritorno
	btfss	switch_4
	goto	_effetto_3c_ritorno
	bcf	led_4
	return
_effetto_3b_ritorno
	bcf	led_5
	return
_effetto_3c_ritorno
	bcf	led_6
	return

_effetto_2_ritorno
	btfss	switch_3
	goto	_effetto_2a_ritorno
	btfss	switch_4
	goto	_effetto_2b_ritorno
	clrf	PORT_B
	return
_effetto_2a_ritorno
	btfss	switch_4
	goto	_effetto_2c_ritorno
	bcf	led_3
	return
_effetto_2b_ritorno
	bcf	led_4
	return	
_effetto_2c_ritorno
	bcf	led_5
	return	

_effetto_1_ritorno
	btfss	switch_3
	goto	_effetto_1a_ritorno
	btfss	switch_4
	goto	_effetto_1b_ritorno
	clrf	PORT_B			; 1 led 
	return
_effetto_1a_ritorno
	btfss	switch_4
	goto	_effetto_1c_ritorno
	bcf	led_2			; 2 led
	return
_effetto_1b_ritorno
	bcf	led_3			; 3 led
	return
_effetto_1c_ritorno
	bcf	led_4			; 4 led
	return

_effetto_1_end
	btfss	switch_3
	goto	_effetto_1_end_a
	btfss	switch_4
	goto	_effetto_1_end_b
	call	_velocit
	bcf	led_1
	return
_effetto_1_end_a
	btfss	switch_4
	goto	_effetto_1_end_c
	call	_velocit
	bcf	led_2
	call	_velocit
	return
_effetto_1_end_b
	call	_velocit
	bcf	led_3
	call	_velocit
	bcf	led_2
	call	_velocit
	return
_effetto_1_end_c
	call	_velocit
	bcf	led_4
	call	_velocit
	bcf	led_3
	call	_velocit
	bcf	led_2
	call	_velocit
	return



;*************************************************************

	
	
	END






	

